
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Voyager.Actions.ModellingAndProQ3D &#8212; PhaserVoyager 0.0.1 documentation</title>
    <link rel="stylesheet" href="../../../_static/sphinxdoc.css" type="text/css" />
    <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../../_static/language_data.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../index.html" accesskey="U">Module code</a> &#187;</li>
      </ul>
    </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">

  <h1>Source code for Voyager.Actions.ModellingAndProQ3D</h1><div class="highlight"><pre>
<span></span>
<span class="c1">#! /usr/bin/env python</span>
<span class="c1"># -*- coding: utf-8 -*-</span>

<span class="c1">#####################################################################</span>
<span class="c1">#  Copyright and authorship belong to:                              #</span>
<span class="c1">#  @author: Massimo Sammito                                         #</span>
<span class="c1">#  @email: mds83@cam.ac.uk / massimo.sammito@gmail.com              #</span>
<span class="c1">#####################################################################</span>
<span class="c1">#####################################################################</span>
<span class="c1">#                              LICENSE                              #</span>
<span class="c1">#                                                                   #</span>
<span class="c1">#                                                                   #</span>
<span class="c1">#####################################################################</span>

<span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">print_function</span>
<span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">division</span>
<span class="kn">from</span> <span class="nn">future.standard_library</span> <span class="kn">import</span> <span class="n">install_aliases</span>
<span class="kn">from</span> <span class="nn">libtbx.phil</span> <span class="kn">import</span> <span class="n">parse</span>

<span class="n">install_aliases</span><span class="p">()</span>

<span class="kn">import</span> <span class="nn">sys</span><span class="o">,</span><span class="nn">os</span>
<span class="kn">import</span> <span class="nn">traceback</span>
<span class="kn">import</span> <span class="nn">networkx</span> <span class="k">as</span> <span class="nn">nx</span>
<span class="kn">from</span> <span class="nn">voyager_actions</span> <span class="kn">import</span> <span class="n">Action</span>
<span class="kn">import</span> <span class="nn">sculptor_functions</span>

<span class="c1">#DISCLAIMER#</span>
<span class="c1">#This class has been generated automatically through strategy_app.py</span>
<span class="c1">#The app does not verify the correctness of the written code</span>
<span class="c1">#Please validate the class before use and manually inspect and correct any error</span>

<div class="viewcode-block" id="ModellingAndProQ3D_exception"><a class="viewcode-back" href="../../../Voyager.Actions.ModellingAndProQ3D.html#Voyager.Actions.ModellingAndProQ3D.ModellingAndProQ3D_exception">[docs]</a><span class="k">class</span> <span class="nc">ModellingAndProQ3D_exception</span><span class="p">(</span><span class="ne">Exception</span><span class="p">):</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">msg</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">(</span><span class="n">ModellingAndProQ3D_exception</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">msg</span><span class="p">)</span></div>

<div class="viewcode-block" id="ModellingAndProQ3D"><a class="viewcode-back" href="../../../Voyager.Actions.ModellingAndProQ3D.html#Voyager.Actions.ModellingAndProQ3D.ModellingAndProQ3D">[docs]</a><span class="k">class</span> <span class="nc">ModellingAndProQ3D</span><span class="p">(</span><span class="n">Action</span><span class="p">):</span>
    <span class="n">info_dag_nodes</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;hkl_input&quot;</span><span class="p">:</span><span class="s2">&quot;0&quot;</span><span class="p">,</span><span class="s2">&quot;hkl_output&quot;</span><span class="p">:</span><span class="s2">&quot;0&quot;</span><span class="p">,</span><span class="s2">&quot;model_input&quot;</span><span class="p">:</span><span class="s2">&quot;*&quot;</span><span class="p">,</span><span class="s2">&quot;model_output&quot;</span><span class="p">:</span><span class="s2">&quot;*&quot;</span><span class="p">,</span><span class="s2">&quot;occurrences&quot;</span><span class="p">:</span><span class="s2">&quot;1&quot;</span><span class="p">}</span>
    <span class="n">rule</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;[[&quot;ModelExtraction&quot;]]&quot;&quot;&quot;</span>
    <span class="n">phasertngphil</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;&quot;&quot;&quot;</span>
    <span class="n">masterphil</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;voyager.ModellingAndProQ3D {</span>
<span class="s2">modeling_method = rosetta *modeller skip</span>
<span class="s2">      .type = choice(multi=False)</span>
<span class="s2">      .expert_level = 0</span>
<span class="s2">      .optional = True</span>
<span class="s2">      .short_caption = Homology modelling method  </span>
<span class="s2">      .help = Method to modelling side chains of the target structure in the homolog </span>
<span class="s2">error_estimation = *proq3d skip</span>
<span class="s2">      .type = choice(multi=False)</span>
<span class="s2">      .expert_level = 0</span>
<span class="s2">      .optional = True</span>
<span class="s2">      .short_caption = Error estimation method  </span>
<span class="s2">      .help = Method to estimate rms errors and encoding them as b-factors </span>
<span class="s2">modeller_path = modeller</span>
<span class="s2">      .type = path</span>
<span class="s2">      .expert_level = 0</span>
<span class="s2">      .optional = True</span>
<span class="s2">      .short_caption = Modeller binary path </span>
<span class="s2">      .help = Absolute path of Modeller binary software</span>
<span class="s2">}&quot;&quot;&quot;</span>
    <span class="n">helpstring</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot; Perform a Sculptor action and apply Modelling with Modeller or Rosetta. Then perform an error estimation of the coordinates interrogating the ProQ3D server and map the result into B-factors to reflect the predict errors.&quot;&quot;&quot;</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">strategy</span><span class="p">,</span> <span class="n">current_phil_keywords</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="s1">&#39;ModellingAndProQ3D&#39;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span> <span class="o">=</span> <span class="n">strategy</span><span class="o">.</span><span class="n">arguments</span>
        <span class="nb">super</span><span class="p">(</span><span class="n">ModellingAndProQ3D</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">strategy</span><span class="p">,</span> <span class="n">current_phil_keywords</span><span class="p">)</span>


<div class="viewcode-block" id="ModellingAndProQ3D.check_imports"><a class="viewcode-back" href="../../../Voyager.Actions.ModellingAndProQ3D.html#Voyager.Actions.ModellingAndProQ3D.ModellingAndProQ3D.check_imports">[docs]</a>    <span class="k">def</span> <span class="nf">check_imports</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">b</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">test</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;test() method has not been implemented!&quot;</span><span class="p">)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">c</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">help</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;help() method has not been implemented!&quot;</span><span class="p">)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">d</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_name</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;get_name() method has not been implemented!&quot;</span><span class="p">)</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">copy</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;copy&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">iotbx</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;iotbx&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">simple_tools</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;simple_tools&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">shutil</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;shutil&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">pdb_structure</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;pdb_structure&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">any_file</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;iotbx.file_reader&quot;</span><span class="p">,</span> <span class="n">fromlist</span><span class="o">=</span><span class="p">[</span><span class="s2">&quot;any_file&quot;</span><span class="p">])</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">pdb_structure</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;pdb_structure&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">system_utility</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;system_utility&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Sculptor</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;Actions.Sculptor&quot;</span><span class="p">)</span>

        <span class="k">return</span> <span class="kc">True</span></div>

<div class="viewcode-block" id="ModellingAndProQ3D.test"><a class="viewcode-back" href="../../../Voyager.Actions.ModellingAndProQ3D.html#Voyager.Actions.ModellingAndProQ3D.ModellingAndProQ3D.test">[docs]</a>    <span class="k">def</span> <span class="nf">test</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="c1">#TODO: perform a complete self contained test</span>
        <span class="k">pass</span></div>

<div class="viewcode-block" id="ModellingAndProQ3D.help"><a class="viewcode-back" href="../../../Voyager.Actions.ModellingAndProQ3D.html#Voyager.Actions.ModellingAndProQ3D.ModellingAndProQ3D.help">[docs]</a>    <span class="k">def</span> <span class="nf">help</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">helpstring</span></div>

<div class="viewcode-block" id="ModellingAndProQ3D.get_name"><a class="viewcode-back" href="../../../Voyager.Actions.ModellingAndProQ3D.html#Voyager.Actions.ModellingAndProQ3D.ModellingAndProQ3D.get_name">[docs]</a>    <span class="k">def</span> <span class="nf">get_name</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">name</span></div>

<div class="viewcode-block" id="ModellingAndProQ3D.run"><a class="viewcode-back" href="../../../Voyager.Actions.ModellingAndProQ3D.html#Voyager.Actions.ModellingAndProQ3D.ModellingAndProQ3D.run">[docs]</a>    <span class="k">def</span> <span class="nf">run</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">notify_start</span><span class="p">()</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s2">&quot;logger&quot;</span><span class="p">):</span> <span class="k">raise</span> <span class="n">ModellingAndProQ3D_exception</span><span class="p">(</span><span class="s2">&quot;Logger File has not been set. Please call &#39;set_logger_file&#39; method before run&quot;</span><span class="p">)</span>
        <span class="n">user_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">python_object</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span><span class="p">)</span>
        <span class="n">diffuser_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch_diff</span><span class="p">(</span><span class="n">source</span><span class="o">=</span><span class="n">user_phil</span><span class="p">)</span>
        <span class="n">action_phil</span> <span class="o">=</span> <span class="n">parse</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">current_phil_keywords</span><span class="p">)</span>
        <span class="n">diffaction_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch_diff</span><span class="p">(</span><span class="n">source</span><span class="o">=</span><span class="n">action_phil</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch</span><span class="p">(</span><span class="n">sources</span><span class="o">=</span><span class="p">[</span><span class="n">diffaction_phil</span><span class="p">,</span><span class="n">diffuser_phil</span><span class="p">])</span><span class="o">.</span><span class="n">extract</span><span class="p">()</span>
        <span class="n">output</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">modelling_and_error_estimation</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">notify_end</span><span class="p">()</span>
        <span class="k">return</span> <span class="n">output</span></div>

<div class="viewcode-block" id="ModellingAndProQ3D.modelling_and_error_estimation"><a class="viewcode-back" href="../../../Voyager.Actions.ModellingAndProQ3D.html#Voyager.Actions.ModellingAndProQ3D.ModellingAndProQ3D.modelling_and_error_estimation">[docs]</a>    <span class="k">def</span> <span class="nf">modelling_and_error_estimation</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">argsparse</span><span class="p">):</span>
        <span class="n">root</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">initial_dag_nodes</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">root</span><span class="p">,</span> <span class="nb">list</span><span class="p">):</span> <span class="n">root</span> <span class="o">=</span> <span class="p">[</span><span class="n">root</span><span class="p">]</span>
        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">root</span><span class="p">)</span> <span class="o">&lt;</span> <span class="mi">1</span><span class="p">:</span>
            <span class="k">raise</span> <span class="n">ModellingAndProQ3D_exception</span><span class="p">(</span><span class="s2">&quot;This action cannot be the root of a PhaserDAG&quot;</span><span class="p">)</span>

        <span class="k">if</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">ModellingAndProQ3D</span><span class="o">.</span><span class="n">error_estimation</span> <span class="o">==</span> <span class="s2">&quot;skip&quot;</span><span class="p">:</span> <span class="k">return</span> <span class="n">root</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">sculptorinstance</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">Sculptor</span><span class="o">.</span><span class="n">Sculptor</span><span class="o">.</span><span class="n">Sculptor</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="p">,</span> <span class="s2">&quot;&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">sculptorinstance</span><span class="o">.</span><span class="n">check_imports</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">sculptorinstance</span><span class="o">.</span><span class="n">set_logger_file</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="p">)</span>

        <span class="k">for</span> <span class="n">ele</span> <span class="ow">in</span> <span class="n">root</span><span class="p">:</span>
            <span class="n">elements</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="k">for</span> <span class="n">ln</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">successors</span><span class="p">(</span><span class="n">ele</span><span class="p">):</span>
                <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">ln</span><span class="p">)[</span><span class="s2">&quot;type&quot;</span><span class="p">]</span> <span class="o">==</span> <span class="s2">&quot;modelcontainer&quot;</span><span class="p">:</span>
                    <span class="n">elements</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">ln</span><span class="p">)</span>
                    <span class="k">for</span> <span class="n">ql</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">successors</span><span class="p">(</span><span class="n">ln</span><span class="p">):</span>
                        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">ql</span><span class="p">)[</span><span class="s2">&quot;type&quot;</span><span class="p">]</span> <span class="o">==</span> <span class="s2">&quot;modelcontainer&quot;</span><span class="p">:</span>
                            <span class="n">elements</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">ql</span><span class="p">)</span>

            <span class="n">basedir</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">simple_tools</span><span class="o">.</span><span class="n">create_directory_timestamp</span><span class="p">(</span><span class="s2">&quot;errorestimation_&quot;</span><span class="p">)</span>

            <span class="n">pdblist</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="k">for</span> <span class="n">el</span> <span class="ow">in</span> <span class="n">elements</span><span class="p">:</span>
                <span class="n">x</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">descendants</span><span class="p">(</span><span class="n">el</span><span class="p">)</span>
                <span class="n">dt</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">el</span><span class="p">)[</span><span class="s2">&quot;data&quot;</span><span class="p">][</span><span class="s2">&quot;chain_pdb&quot;</span><span class="p">]</span>
                <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">x</span><span class="p">:</span>
                    <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">p</span><span class="p">)[</span><span class="s2">&quot;name&quot;</span><span class="p">]</span> <span class="o">==</span> <span class="s2">&quot;modelcontainer&quot;</span><span class="p">:</span>
                        <span class="n">dt</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">p</span><span class="p">)[</span><span class="s2">&quot;data&quot;</span><span class="p">][</span><span class="s2">&quot;chain_pdb&quot;</span><span class="p">])</span>
                <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">x</span><span class="p">:</span>
                    <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">p</span><span class="p">)[</span><span class="s2">&quot;name&quot;</span><span class="p">]</span> <span class="o">==</span> <span class="s2">&quot;pdb&quot;</span><span class="p">:</span>
                        <span class="n">ttt</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">schedule_extract_from_db</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">p</span><span class="p">)[</span><span class="s2">&quot;model_identifier&quot;</span><span class="p">],</span>
                                                            <span class="n">where</span><span class="o">=</span><span class="n">basedir</span><span class="p">)</span>
                        <span class="n">pdblist</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">dt</span><span class="p">[</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">basename</span><span class="p">(</span><span class="n">ttt</span><span class="p">[</span><span class="mi">0</span><span class="p">])[:</span><span class="o">-</span><span class="mi">4</span><span class="p">]],</span> <span class="n">ttt</span><span class="p">[</span><span class="mi">0</span><span class="p">]))</span>

            <span class="n">alignments_from_hhpred</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">elements</span><span class="p">[</span><span class="mi">0</span><span class="p">])[</span><span class="s2">&quot;data&quot;</span><span class="p">][</span><span class="s2">&quot;alignments_from_hhpred&quot;</span><span class="p">]</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="n">files</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">elements</span><span class="p">[</span><span class="mi">0</span><span class="p">])[</span><span class="s2">&quot;data&quot;</span><span class="p">][</span><span class="s2">&quot;files&quot;</span><span class="p">]</span>
                <span class="n">alipath</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">basedir</span><span class="p">,</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">basename</span><span class="p">(</span><span class="n">files</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]))</span>  <span class="c1"># the last one is the most updated alignment</span>
            <span class="k">except</span><span class="p">:</span>
                <span class="c1"># print(sys.exc_info())</span>
                <span class="c1"># traceback.print_exc(file=sys.stdout)</span>
                <span class="n">alipath</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">elements</span><span class="p">[</span><span class="mi">0</span><span class="p">])[</span><span class="s2">&quot;data&quot;</span><span class="p">][</span><span class="s2">&quot;alipath&quot;</span><span class="p">]</span>

            <span class="c1"># print(alipath)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">schedule_extract_from_db</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">elements</span><span class="p">[</span><span class="mi">0</span><span class="p">])[</span><span class="s2">&quot;model_identifier&quot;</span><span class="p">],</span> <span class="n">where</span><span class="o">=</span><span class="n">basedir</span><span class="p">)</span>

            <span class="n">seqstr</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">elements</span><span class="p">[</span><span class="mi">0</span><span class="p">])[</span><span class="s2">&quot;data&quot;</span><span class="p">][</span><span class="s2">&quot;sequence&quot;</span><span class="p">]</span>
            <span class="n">alisource</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">elements</span><span class="p">[</span><span class="mi">0</span><span class="p">])[</span><span class="s2">&quot;data&quot;</span><span class="p">][</span><span class="s2">&quot;alisource&quot;</span><span class="p">]</span>
            <span class="n">sculptor_mode</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">elements</span><span class="p">[</span><span class="mi">0</span><span class="p">])[</span><span class="s2">&quot;data&quot;</span><span class="p">][</span><span class="s2">&quot;sculptor_mode&quot;</span><span class="p">]</span>
            <span class="n">extracted_entries</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">elements</span><span class="p">[</span><span class="mi">0</span><span class="p">])[</span><span class="s2">&quot;data&quot;</span><span class="p">][</span><span class="s2">&quot;extracted_entries&quot;</span><span class="p">]</span>

            <span class="n">dictio</span> <span class="o">=</span> <span class="p">{</span>
                <span class="s2">&quot;recover_original_numbers_and_sequence&quot;</span><span class="p">:</span> <span class="kc">True</span><span class="p">,</span>
                <span class="s2">&quot;alignment_based_superposition&quot;</span><span class="p">:</span> <span class="kc">False</span><span class="p">,</span>
                <span class="s2">&quot;modeling_method&quot;</span><span class="p">:</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">ModellingAndProQ3D</span><span class="o">.</span><span class="n">modeling_method</span><span class="p">,</span>
                <span class="s2">&quot;error_estimation&quot;</span><span class="p">:</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">ModellingAndProQ3D</span><span class="o">.</span><span class="n">error_estimation</span><span class="p">,</span>
                <span class="s2">&quot;perform_if_best_sequence_identity_is_lower_than&quot;</span><span class="p">:</span> <span class="mf">0.0</span><span class="p">,</span>
                <span class="s2">&quot;fixed_vrms&quot;</span><span class="p">:</span> <span class="mf">1.0</span><span class="p">,</span>
                <span class="s2">&quot;modeller_path&quot;</span><span class="p">:</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">ModellingAndProQ3D</span><span class="o">.</span><span class="n">modeller_path</span><span class="p">,</span>
                <span class="s2">&quot;vrms_function&quot;</span><span class="p">:</span> <span class="s2">&quot;oeffner&quot;</span><span class="p">,</span>
                <span class="s2">&quot;phaserSculptor&quot;</span><span class="p">:</span> <span class="n">sculptor_functions</span><span class="o">.</span><span class="n">master_phil</span><span class="p">}</span>
            <span class="n">final_sculpted</span><span class="p">,</span> <span class="n">nosculpted</span><span class="p">,</span> <span class="n">modifications</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">sculptorinstance</span><span class="o">.</span><span class="n">sculpting</span><span class="p">(</span><span class="n">dictio</span><span class="p">,</span> <span class="n">basedir</span><span class="p">,</span> <span class="n">sculptor_mode</span><span class="p">,</span> <span class="n">alisource</span><span class="p">,</span>
                                                                       <span class="n">alipath</span><span class="p">,</span> <span class="n">pdblist</span><span class="p">,</span> <span class="n">alignments_from_hhpred</span><span class="p">,</span> <span class="n">seqstr</span><span class="p">,</span>
                                                                       <span class="n">ele</span><span class="p">,</span> <span class="n">evaluate</span><span class="o">=</span><span class="n">extracted_entries</span><span class="p">)</span>

            <span class="n">data</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;files&quot;</span><span class="p">:</span> <span class="p">[</span><span class="n">alipath</span><span class="p">],</span>
                    <span class="s2">&quot;alignments_from_hhpred&quot;</span><span class="p">:</span> <span class="n">alignments_from_hhpred</span><span class="p">,</span> <span class="s2">&quot;sequence&quot;</span><span class="p">:</span> <span class="n">seqstr</span><span class="p">,</span>
                    <span class="s2">&quot;alisource&quot;</span><span class="p">:</span> <span class="n">alisource</span><span class="p">,</span>
                    <span class="s2">&quot;sculptor_mode&quot;</span><span class="p">:</span> <span class="n">sculptor_mode</span><span class="p">,</span> <span class="s2">&quot;extracted_entries&quot;</span><span class="p">:</span> <span class="n">extracted_entries</span><span class="p">,</span>
                    <span class="s2">&quot;chain_pdb&quot;</span><span class="p">:</span> <span class="p">{</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">basename</span><span class="p">(</span><span class="n">x</span><span class="p">)[:</span><span class="o">-</span><span class="mi">4</span><span class="p">]:</span> <span class="bp">self</span><span class="o">.</span><span class="n">pdb_structure</span><span class="o">.</span><span class="n">PDB</span><span class="p">(</span><span class="n">x</span><span class="p">)</span><span class="o">.</span><span class="n">seqbychain</span><span class="o">.</span><span class="n">keys</span><span class="p">()[</span><span class="mi">0</span><span class="p">]</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span>
                                  <span class="n">final_sculpted</span><span class="p">},</span> <span class="s2">&quot;modifications&quot;</span><span class="p">:</span> <span class="kc">None</span><span class="p">}</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">schedule_add_node_model</span><span class="p">(</span><span class="n">final_sculpted</span><span class="p">,</span> <span class="s2">&quot;ErrorEstimation&quot;</span><span class="p">,</span> <span class="n">data</span><span class="p">,</span> <span class="n">ele</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">associated_strategy_node</span><span class="p">,</span>
                                         <span class="n">probability</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">rank</span><span class="o">=</span><span class="kc">None</span><span class="p">)</span>

            <span class="bp">self</span><span class="o">.</span><span class="n">shutil</span><span class="o">.</span><span class="n">rmtree</span><span class="p">(</span><span class="n">basedir</span><span class="p">)</span>
            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">final_sculpted</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
                <span class="n">ttt</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="n">final_sculpted</span><span class="p">[</span><span class="mi">0</span><span class="p">])[</span><span class="mi">0</span><span class="p">]</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">shutil</span><span class="o">.</span><span class="n">rmtree</span><span class="p">(</span><span class="n">ttt</span><span class="p">)</span>
            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">nosculpted</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
                <span class="n">ttt</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="n">nosculpted</span><span class="p">[</span><span class="mi">0</span><span class="p">])[</span><span class="mi">0</span><span class="p">]</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">shutil</span><span class="o">.</span><span class="n">rmtree</span><span class="p">(</span><span class="n">ttt</span><span class="p">)</span>

        <span class="k">return</span> <span class="n">root</span></div></div>
</pre></div>

          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../index.html" >Module code</a> &#187;</li>
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2020, Massimo D. Sammito.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.8.5.
    </div>
  </body>
</html>